SystemOrganization addCategory: #IAN_simulation!

PolygonMorph subclass: #IAN_barrier
	instanceVariableNames: 'inField dropRate drMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_barrier methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 23:19'!
drMorph
^drMorph! !

!IAN_barrier methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 23:19'!
drMorph: aM
drMorph := aM! !

!IAN_barrier methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/21/2014 11:10'!
dropRate: aVal 
"0 to 1"
dropRate := aVal.
self color: ((self color) alpha:  ((aVal * 0.5) + 0.25)). " squeezes visual effect into 0.25-0.75 alpha"
self drMorph contents: ((1 -aVal) asString) .
self changed. 

! !

!IAN_barrier methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 13:17'!
handlesMouseDown: evt 
(evt controlKeyPressed ) ifFalse: [ ^self inField ].
 ^true
! !

!IAN_barrier methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 12:53'!
hasClock
^false! !

!IAN_barrier methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 12:43'!
inField
^inField! !

!IAN_barrier methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 12:43'!
inField: aBoolean 
inField := aBoolean! !

!IAN_barrier methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 23:23'!
initialize 
super initialize .
self inField: false.
dropRate = 0.5 .
self drMorph: (StringMorph new ; contents: (dropRate asString) ).
self addMorphCentered: drMorph! !

!IAN_barrier methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/21/2014 11:06'!
mouseDown: evt
	evt controlKeyPressed
		ifTrue: [ World primaryHand attachMorph: self copy ]
		ifFalse: [ 
			evt shiftPressed
				ifTrue: [ 
					inField
						ifTrue: [ self dropRate: ( 1- (self userValue ))
							] ] ]! !

!IAN_barrier methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 21:24'!
statDel
| drop |
drop:= ((100 atRandom) < (100* dropRate)).
^drop! !

!IAN_barrier methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/21/2014 11:05'!
userValue
	| inP |
	[ 	inP := CommandLineUIManager default
			textEntry: 'PassRate value 0.0 to 1.0 (0 = drop all)'
			title: 'Packet filter Pass Rate'
			entryText: '0.5'.
		inP ifNil: [ inP := '0.5' ] .
		inP matchesRegex: '(\+)?\d+(\.\d+)?' ] whileFalse.
^ inP asNumber! !

PolygonMorph subclass: #IAN_stateChanger
	instanceVariableNames: 'name target action document myOC'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

IAN_stateChanger subclass: #IAN_choice
	instanceVariableNames: 'guard'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_choice methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/14/2014 16:32'!
initialize 
super initialize .
self color: Color lightOrange   .
self extent: (2@2) ; position: self position + (20 atRandom @ 20 atRandom) .
! !

IAN_stateChanger subclass: #IAN_initial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_initial methodsFor: 'as yet unclassified' stamp: 'PGH 2/16/2014 09:58'!
initialize 
super initialize .
self color: Color lightBlue  .



! !

!IAN_initial methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/20/2014 16:14'!
myglyph: options 
super myglyph: options color: Color black.! !

!IAN_initial methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/25/2014 09:29'!
target
^target! !

!IAN_initial methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/25/2014 09:32'!
yourtitleData: anArray
| args |
args := String newFrom: ((anArray at: 2) asArray ).

target  := (args findTokens: $/ ) collect: [ :e | e asString ].

! !

!IAN_stateChanger methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/15/2014 13:38'!
fillDataWith: anOC 
| my_glyph val i str |
" read strings into inst vars until endOc (=/px) seen "
myOC := anOC.
" lookfor glyph"
str := self className .
"drop IAN_"
str := str copyFrom: ('IAN_' size + 1) to: (str size).
my_glyph := (str,'_glyph')  asOrderedCollection . " example state_glyph"

i := 1.

val :=( myOC at: i) copyFrom: 1 to: ((my_glyph size) min: ((myOC at: i) size)).  " step thru top level of ordered collection"

[(val  = my_glyph) or: [ i = (myOC size) ] ] whileFalse: [  val :=( myOC at: (i := i +1) ) copyFrom: 1 to: ((my_glyph size) min: ((myOC at: i ) size)) ].

val := myOC at: i . " get full token back"
"found <state_glyph node=aString/>"
" aString is double quted and holds x,y,a,b x,y is start point and a,b is end point "
" find double quote poisitions in collection"

self myglyph: (self varData: val )


! !

!IAN_stateChanger methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/15/2014 17:59'!
myglyph: aValueWeDontCareAbout
"this is overridden by subclasses"! !

!IAN_stateChanger methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/21/2014 09:10'!
myglyph: options color: aColor

| val valS valSe deltaXY myVerts startPoint beginXorY  |

val := options at: 2. "first option is type_name, second is xy data"

deltaXY := OrderedCollection  new .
myVerts := OrderedCollection  new .

valS := String newFrom: val .

valSe := (valS findTokens: $, ) collect: [ :e | e asInteger ].

beginXorY := (valSe at: 3) \\ 2. " a guess?"
startPoint := ((valSe at:1 ) @ (valSe at: 2)) .
deltaXY := valSe copyFrom: 5 to: (valSe size) .

myVerts addLast: startPoint * 4. "crude scale"
deltaXY := deltaXY collect: [ :e | e*4 ].

deltaXY do: [ :aDelta | myVerts addLast: ( myVerts last  + ((aDelta * beginXorY ) @ (aDelta *(1-beginXorY)))). beginXorY := (beginXorY +1) \\2  ].


self vertices: myVerts color: aColor .
self beStraightSegments ; makeForwardArrow ; makeOpen .

self submorphsDo: [  :each | each position: each position - startPoint ].! !

!IAN_stateChanger methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/25/2014 09:36'!
varData: nx

	| i type val nextsp nextdQ answer reply |

	i := 1.
	answer := OrderedCollection new.
	(nx includes: $=)
		ifTrue: [ 
			i := 1.
			[i = ((nx size) - 1)] whileFalse: [ 
					[ (nx at: i) = (Character space) ] whileFalse: [ i := i + 1 ].
					nextsp := i.
					[ (nx at: i) = $" ] whileFalse: [ i := i + 1 ].
					nextdQ := i.
					type := nx copyFrom: nextsp +1 to: nextdQ - 2.
					[ (nx at:  i + 1) = $" ] whileFalse: [ i := i + 1 ].	"+1 moves over  first doublequote finds next doublequote"
					val := nx copyFrom: nextdQ + 1 to:  i .
					answer addLast: type.
					answer addLast: val.
			 ].
		reply := answer collect: [  :each | each asArray  ].
		^reply
		]
	ifFalse: [  ^Array with: #($n $o $n $e ) with:  #($n $o $n $e ) ].! !

!IAN_stateChanger methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/15/2014 12:50'!
yourtitleData: anArray
"blank for now"! !

IAN_stateChanger subclass: #IAN_tran
	instanceVariableNames: 'trigger'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_tran methodsFor: 'as yet unclassified' stamp: 'PGH 2/16/2014 09:58'!
initialize 
super initialize .
self color: Color lightMagenta   .



! !

!IAN_tran methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/20/2014 16:14'!
myglyph: options 
super myglyph: options color: Color red.! !

!IAN_tran methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/15/2014 17:44'!
name
^name! !

!IAN_tran methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/15/2014 17:44'!
name: aString 
name := aString ! !

!IAN_tran methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/24/2014 17:11'!
target
^target! !

!IAN_tran methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/24/2014 17:11'!
target: val 
target := val! !

!IAN_tran methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 09:14'!
trigger
 ^trigger! !

!IAN_tran methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 09:14'!
trigger: aBlock
trigger := aBlock! !

!IAN_tran methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/25/2014 09:35'!
yourtitleData: anArray

|  args  |

trigger := String newFrom: ((anArray at: 2) asArray ).

args := String newFrom: ((anArray at: 4) asArray ). 

target  := (args findTokens: $/ ) collect: [ :e | e asString ]. 
! !

!PolygonMorph methodsFor: '*IAN_simulation' stamp: 'PhilipHunt 2/20/2014 15:10'!
vertices: verts color: aColor 
	vertices := verts.
	color := aColor.
	borderWidth := 1.
	borderColor := aColor.
	closed := vertices size > 2.
	arrows := #none.
	self computeBounds! !

BorderedMorph subclass: #IAN_Node
	instanceVariableNames: 'myName inField wiggle myClock flashMorph temp mySM'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

IAN_Node subclass: #IAN_CC
	instanceVariableNames: 'myType myENs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_CC methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:43'!
handlesMouseDown: evt 
(evt controlKeyPressed ) ifFalse: [ ^self inField ].
 ^true
! !

!IAN_CC methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:46'!
mouseDown: evt
	evt controlKeyPressed
		ifTrue: [ World primaryHand attachMorph: self copy ]
		ifFalse: [ 
			evt shiftPressed
				ifTrue: [ 
					inField
						ifTrue: [ 
							wiggle := 0.
							self startStepping.
							myClock startStepping.
							myClock
								setupJobat: (myClock myTime + 40) \\ 10000
								for: Transcript
								selector: 'show:'
								toGet: #('hello from CC') ] ]
				ifFalse: [ self findENs do: [ :anEN | self sendToEN: anEN message: 'hi' ] ] ]! !

!IAN_CC methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/26/2014 16:47'!
myENs
^myENs! !

!IAN_CC methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/26/2014 16:48'!
myENs: anArray 
myENs := anArray! !

!IAN_CC methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:44'!
myType
^ myType! !

!IAN_CC methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:44'!
myType: aString 
myType := aString! !

!IAN_CC methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/23/2014 12:36'!
sendToEN: anEN message: aMessage
|  blob time |
" send a basic message to a particular EN"
Transcript cr.
Transcript show: self myName, ' Sent to an EN called :- ',(anEN myName),' message :- ' ; show: aMessage ; cr.

" now send a small blob morph to the EN"
blob := IAN_message new.
self owner addMorphCentered: blob .
blob setBarrierList .
blob startPosition: self center.
blob targetPosition: anEN center.
blob target: anEN .
time := self myClock myTime .

blob message: (Array with: 'changeTime:' with: time)
! !

IAN_Node subclass: #IAN_EN
	instanceVariableNames: 'myType myCC'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_EN methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:42'!
handlesMouseDown: evt 
(evt controlKeyPressed ) ifFalse: [ ^self inField ].
 ^true
! !

!IAN_EN methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/9/2014 12:19'!
initialize 
super initialize ! !

!IAN_EN methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/25/2014 17:21'!
mouseDown: evt
	evt controlKeyPressed
		ifTrue: [ World primaryHand attachMorph: self copy ]
		ifFalse: [ 
			evt shiftPressed
				ifTrue: [ 
					inField
						ifTrue: [ 
							wiggle := 0.
							self startStepping.
							myClock startStepping.
							myClock
								setupJobat: (myClock myTime + 40) \\ 10000
								for: Transcript
								selector: 'show:'
								toGet: #('hello') ] ]
				ifFalse: [ "self findCCs do: [ :aCC | self sendToCC: aCC message: 'sending...' ]" mySM signal: 'push' ] ]! !

!IAN_EN methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/26/2014 16:46'!
myCC
^myCC! !

!IAN_EN methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/26/2014 16:46'!
myCC: aNode 
myCC := aNode! !

!IAN_EN methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:30'!
myType
^myType ! !

!IAN_EN methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:30'!
myType: aString 
myType := aString! !

!IAN_EN methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/21/2014 15:59'!
sendToCC: aCC message: aMessage
| blob |
" send a basic message to a particular cc"
Transcript cr.
Transcript show: self myName, ' Sent to a CC called :- ',(aCC myName),' message :- ' ; show: aMessage ; cr.

" now send a small blob morph to the CC"
blob := IAN_message new.
self owner addMorphCentered: blob .
blob setBarrierList .
blob startPosition: self center.
blob targetPosition: aCC center.
blob target: aCC.
blob message: { 'flashOnce' }

! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/23/2014 12:15'!
acceptDroppingMorph: aMorph event: evt 
" we only accept statemachines from the hand see wantsDropped"
self addMorph:  aMorph .
mySM := aMorph.
aMorph position: (self position).
aMorph inNode: true.
^true
! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/26/2014 17:01'!
bleRx: anArray 
" incoming messages are performed here"
" later we might have many receivers but at first this is the switchyard"
mySM  signal: anArray ! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/26/2014 17:14'!
bleTx: anArray
self findCCs do: [ :aCC | self sendToCC: aCC message: anArray ]! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 14:34'!
changeName: aNum 
" use our name and add a counter (num) as a unique"
| subs t ourType|
ourType := self myType.
"find our text submorph"
subs := self submorphs .
subs isEmpty ifTrue:  [ "no name yet" 
					t := StringMorph new contents: (ourType asString,' ',aNum asString) . 
					self  addMorphCentered: t .
					
					self myName: (ourType asString,' ',aNum asString)
					]
		   ifFalse: [ "find the text morph and change its contents" 
					t := subs select: [  :aSubMorph | aSubMorph class = StringMorph  ].
					( t at: 1 ) contents:  (ourType asString,' ',aNum asString) .
					( t at: 1) center: (self center).
					self myName:  (ourType asString,' ',aNum asString) 
			         ]

! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/6/2014 16:36'!
changeTime: aTime 
"tell our clock to get a new time"
myClock ownTime: aTime! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/2/2014 19:54'!
extent: aPoint
"over ride for largest not smallest"
	| size oldRotationCenter |
	oldRotationCenter := self rotationCenter.
	size := aPoint x max: aPoint y.
	super extent: size @ size.
	self rotationCenter: oldRotationCenter.! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:35'!
findCCs
"ask my owner morph for the cc morphs"
| allCCs |

allCCs := self owner submorphs.
allCCs := allCCs select: [  :type | type class = IAN_CC ].

^allCCs ! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:36'!
findENs
"ask my owner morph for the en morphs"
| allENS |

allENS := self owner submorphs.
allENS := allENS select: [  :type | type class = IAN_EN ].

^allENS ! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:38'!
findMoreLikeYou
	self class = IAN_EN
		ifTrue: [ self findENs ]
		ifFalse: [ self findCCs ]! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/23/2014 19:41'!
flashOnce
flashMorph visible: flashMorph visible not.! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 12:53'!
hasClock
^true! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 22:00'!
inField
^inField! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 23:09'!
inField: aBoolean 
inField := aBoolean! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/9/2014 12:05'!
initialize
	| t pos  |
	super initialize.
	self inField: false.
	pos := self position + (30 @ 39).
	myClock := IAN_clock new.
	myClock position: pos.
	myClock bounds: (pos extent: 45 @ 25).
	self addMorph: myClock.
	wiggle := 0.
	t := StringMorph new contents: (self class asString).
	self addMorphCentered: t .
	" flash morph"
	flashMorph  := PolygonMorph new.
	flashMorph vertices:  { (0@25).(25@50).(0@75).(25@75).(25@100).
	(50@75).(75@100).(75@75).(100@75).(75@50).(100@25).
	(75@25).(75@0).(50@25).(25@0).(25@25) } color: (Color yellow alpha: 0.5) borderWidth:  3 borderColor: Color black ;
		beStraightSegments .
	self addMorph: flashMorph .
	flashMorph hide.  "wait to flashon "
	self stopStepping . temp := 1! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/23/2014 12:33'!
myClock
^myClock! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 1/31/2014 20:12'!
myName
^myName! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/2/2014 20:05'!
myName: aString

myName := aString .
^self ! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 20:57'!
repelsMorph: aMorph event: evt 
^ (self wantsDroppedMorph: aMorph event: evt) not! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/23/2014 19:34'!
step
| leftright |
	"temp behavior"
temp := (temp + 1) \\ 100.
	self inField
		ifTrue: [ 
			" here we can send PUSH"
			leftright := 1 .
			wiggle := wiggle + 1.
			wiggle timesRepeat: [ leftright := leftright * (-1) ].
			wiggle > 6
			ifTrue: [ self position: self position - (((leftright + 1) * 5) @ 0 ).
				    ^ self stopStepping
				 ].
		self position: self position + ( ( leftright * 5) @ 0) . ]


	! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/9/2014 11:29'!
stepTime
^120! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 23:35'!
wantsDroppedMorph: aMorph event: evt 
^((aMorph class = IAN_stateMachine)  and: [(self inField) and: [aMorph hasStates]] )
"^(((aMorph class) = IAN_stateMachine) )"
! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 16:46'!
wiggle
^wiggle! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 15:17'!
wiggle: aVal 
wiggle := aVal! !

BorderedMorph subclass: #IAN_state
	instanceVariableNames: 'name transitions exit entry document num initialTran myOC active'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_state methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/25/2014 10:38'!
active
^active! !

!IAN_state methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/26/2014 09:29'!
active: aBol
active := aBol.
active ifTrue: [ self borderColor: Color blue ; borderWidth: 3 ] ifFalse: [ self borderColor: Color black ; borderWidth: 1]! !

!IAN_state methodsFor: 'initialize-release' stamp: 'PhilipHunt 2/10/2014 10:49'!
addEntry: aBlock
entry := aBlock .
! !

!IAN_state methodsFor: 'initialize-release' stamp: 'PhilipHunt 2/10/2014 10:49'!
addExit: aBlock
exit := aBlock .
! !

!IAN_state methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/26/2014 17:36'!
doEntry
"doEntry decomposes entry into an array for doing"
|  sp |
sp := Character space.

^ ( entry findTokens: sp ) asArray .! !

!IAN_state methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/26/2014 17:37'!
doExit
"doExit decomposes entry into an array for doing"
|  sp |
sp := Character space.

^ ( exit findTokens: sp ) asArray .! !

!IAN_state methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 10:24'!
entry
^entry! !

!IAN_state methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 10:24'!
exit
^exit! !

!IAN_state methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/26/2014 15:12'!
fillDataWith: anOC 
| my_glyph val i str  |
" read strings into inst vars until endOc (=/px) seen "
myOC := anOC.
" lookfor glyph"
str := self className .
"drop IAN_"
str := str copyFrom: ('IAN_' size + 1) to: (str size).
my_glyph := (str,'_glyph')  asOrderedCollection . " example state_glyph"

i := 1.

val :=( myOC at: i) copyFrom: 1 to: ((my_glyph size) min: ((myOC at: i) size)).  " step thru top level of ordered collection"

[(val  = my_glyph) or: [ i = (myOC size) ] ] whileFalse: [  val :=( myOC at: (i := i +1) ) copyFrom: 1 to: ((my_glyph size) min: ((myOC at: i ) size)) ].

val := myOC at: i . " get full token back"
"found <state_glyph node=aString/>"
" aString is double quted and holds x,y,a,b x,y is start point and a,b is end point "
" find double quote poisitions in collection"
self myglyph: val  .

" try to find entry and exit"
entry := nil.
exit := nil.

1 to: (myOC size -2 ) do: [ :indx | entry ifNil: [ entry := self findIn: myOC at: indx  between: 'entry'].
							   	   exit   ifNil: [ exit   := self findIn: myOC at: indx  between: 'exit'  ]   ].


! !

!IAN_state methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/26/2014 15:13'!
findIn: anOC at: index between: aName 
| srt end |

srt :=  (anOC at: index) = (aName asOrderedCollection) .
end := (anOC at: (index +2)) = (('/',aName) asOrderedCollection) .
(srt and: [ end] )
	ifTrue: [ ^String newFrom: ((anOC at: (index +1)) asArray )].
	^nil.! !

!IAN_state methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/25/2014 10:39'!
initialize 
super initialize .
self color: Color lightGreen .
self useRoundedCorners .  "position: self position + (20 atRandom @ 30 atRandom)"
self active: false.! !

!IAN_state methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/26/2014 11:23'!
myglyph: val 
| i firstQ secondQ arg startX startY endX endY start end ss |
i := 1.
[(val at: i) = $" ] whileFalse: [ i := i+1 ] . firstQ := i. i:= i+ 1. "skip that one"
[(val at: i) = $" ] whileFalse: [ i := i+1 ] . secondQ := i.
" each can be one or two or three or more digits as character"  
i  := 1. arg := 0 .
[ (val at: firstQ+ i) = $, ] 			whileFalse: [  arg := (val at: (firstQ+i)) asInteger - ($0 asInteger) + (arg * 10). i := i+1 ]. startX := arg .
i := i+ 1. " skip"
arg := 0.
[ (val at: firstQ+ i) = $, ] 			whileFalse: [  arg := (val at: (firstQ+i)) asInteger - ($0 asInteger) + (arg * 10). i := i+1 ]. startY := arg . 
i := i+ 1. " skip"
arg := 0.	
[ (val at: firstQ+ i) = $, ] 			whileFalse: [  arg := (val at: (firstQ+i)) asInteger - ($0 asInteger) + (arg * 10). i := i+1 ]. endX := arg . 
i := i+ 1. " skip"
arg := 0.			
[ (firstQ+ i) = secondQ ]			whileFalse: [  arg := (val at: (firstQ+i)) asInteger - ($0 asInteger) + (arg * 10). i := i+1 ]. endY := arg . 	
				
				
			start := (startX @ startY) . start :=  start * 4. "crude scale"
			end := (endX @ endY) .	 end := end * 4.
			self position: start  . self extent: end.
			
		
			
		" for each sub morph move them back our position"
		self submorphsDo: [  :each | each position: each position - start ].
		ss :=  (StringMorph contents: name) .
		ss position: (self topCenter + ((ss width //2) negated  @ 3 )).
		self addMorph: ( ss ).	! !

!IAN_state methodsFor: 'initialize-release' stamp: 'PhilipHunt 1/28/2014 13:38'!
name
^name! !

!IAN_state methodsFor: 'actions' stamp: 'PhilipHunt 2/10/2014 10:49'!
name: aString
name := aString
! !

!IAN_state methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 10:23'!
num
^num! !

!IAN_state methodsFor: 'initialize-release' stamp: 'PhilipHunt 2/10/2014 10:50'!
num: anInteger 
num := anInteger! !

!IAN_state methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/24/2014 17:06'!
varData: nx
	" rip off the end of the token"

	" utility only "

	| i type val firstsp firstdQ |
	i := 1.
	(nx includes: $=)
		ifTrue: [ 
			[ (nx at: i) = (Character space) ] whileFalse: [ i := i + 1 ].
			firstsp := i.
			[ (nx at: i) = $" ] whileFalse: [ i := i + 1 ].
			firstdQ := i.
			type := nx copyFrom: firstsp +1 to: firstdQ - 2.
			i := 1.
			[ (nx at: firstdQ +1 + i) = $" ] whileFalse: [ i := i + 1 ].	"+1 moves over  first doublequote finds next doublequote"
			val := nx copyFrom: firstdQ + 1 to: firstdQ + i .
			^ Array with: type asArray with: val asArray ]. ! !

!IAN_state methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/25/2014 09:41'!
yourtitleData: anArray

|  args |

args := String newFrom: ((anArray at: 2) asArray ).

self name: args .
! !

BorderedMorph subclass: #IAN_stateChart
	instanceVariableNames: 'document srcFileName name srcTokens positionInTokens activeState'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

IAN_stateChart class
	instanceVariableNames: 'srcTokens'!

IAN_stateChart class
	instanceVariableNames: 'srcTokens'!

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/25/2014 13:30'!
activeState
^activeState ! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/26/2014 09:22'!
activeState: newState
activeState := newState.
newState active: true.! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 09:10'!
document
^document! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 09:09'!
document: aString 
document := aString! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/14/2014 16:15'!
fillDataWith: anOC 
" read strings into inst vars until endOc (=/px) seen "
| myOC |
myOC := anOC! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/20/2014 16:25'!
initialize 
super initialize .
self color: Color lightCyan   .
! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/24/2014 17:04'!
makeStartingAt: startOcToken onMorph: aMorph
	" recursive decent is implicit for state elements"

	" we read the src tokens and make new element for each token at the same level recurse for those that are themselves states"

	| nx px newMorph s z end  xy statenum |

	statenum := 1.
	
	end := '/' , (self shortName: startOcToken).
	(startOcToken includes: $=)
		ifTrue: [ aMorph yourtitleData: (aMorph varData: startOcToken) ].	"for some this is name=, others have other forms"
			
	px := self shortName: startOcToken .
	z := OrderedCollection new.
	
	[ px = end ]
		whileFalse: [ 
			nx := self nextToken.
			px := self shortName: nx.
			(px = 'state_diagram')
			 ifFalse: [ 
				(#('state' 'tran' 'initial' 'choice') inject: false into: [ :sofar :each | sofar or: [ each = px ] ])
					ifTrue: [ 
						s := 'IAN_' , px.
						newMorph := (Smalltalk at: s asSymbol) new. 
						(px = 'state') ifTrue: [ newMorph num: statenum. statenum := statenum + 1 ].
						aMorph addMorph: newMorph.
						self makeStartingAt: nx onMorph: newMorph
						 ].
					z addLast: nx 
					]
			ifTrue: [ xy :=  ((((String newFrom: nx asArray) findTokens: $" ) at:2) findTokens: $,) collect: [  :e | e asInteger  ]. xy := xy *4 . "same crude scale"
					self extent: ( (xy at: 1) @ (xy at: 2)) ; position: (0 @ 0)].
			].
	aMorph fillDataWith: z! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/25/2014 11:38'!
makeStartingAtTop
| firstOcToken initT states st i val |

positionInTokens := 1 .
firstOcToken :=  self nextToken.
self makeStartingAt: firstOcToken onMorph: self .

self submorphsDo: [  :each | each position: each position - (self position) ].

"initialize state active"
initT := (self submorphs detect: [ :aM | aM class = IAN_initial ]) target .

states := self submorphs select: [  :m | m class = IAN_state ].
i := 1.
(initT size - 1) timesRepeat: [ 
		val := (initT at: (i+1)) asInteger .
		st := states detect: [ :each| each num = val ].
		i := i + 1.
		states := st submorphs select: [  :m | m class = IAN_state ].
		].
activeState:= st.
st active: true.! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 09:09'!
name
 ^name! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 09:08'!
name: aString
name := aString! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/14/2014 16:12'!
nextToken
| nx |
(positionInTokens > srcTokens size) ifTrue: [ ^nil ].
nx := self srcTokens at: positionInTokens .
positionInTokens := positionInTokens +1.
^nx! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/14/2014 13:22'!
shortName: nx
	" utility only "
	| i px |
	i := 1.
	nx addLast: (Character space) .  "add space to end makes stop condition same either way"
	[ (nx at: i) = Character space ] whileFalse: [ i := i + 1 ].
	nx removeLast . " take it off again"
	px := nx copyFrom: 1 to: i - 1.
	^ String newFrom: px asArray! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 09:11'!
srcFileName
^srcFileName ! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 09:10'!
srcFileName: aFile 
srcFileName := aFile ! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 14:28'!
srcTokens
^srcTokens! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 09:52'!
srcTokens: anOC 
srcTokens := anOC ."an ordered collection of tokens"! !

!IAN_stateChart methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/14/2014 14:20'!
varData: nx
	" rip off the end of the token"

	" utility only "

	| i type val firstsp firstdQ |
	i := 1.
	(nx includes: $=)
		ifTrue: [ 
			[ (nx at: i) = (Character space) ] whileFalse: [ i := i + 1 ].
			firstsp := i.
			[ (nx at: i) = $" ] whileFalse: [ i := i + 1 ].
			firstdQ := i.
			type := nx copyFrom: firstsp +1 to: firstdQ - 2.
			i := 1.
			[ (nx at: firstdQ +1 + i) = $" ] whileFalse: [ i := i + 1 ].	"+1 moves over  first doublequote finds next doublequote"
			val := nx copyFrom: firstdQ + 1 to: firstdQ + i .
			^ Array with: type asArray with: val asArray ]. ! !

PluggableTextMorph subclass: #IAN_logMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_logMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/9/2014 12:52'!
acceptDroppingMorph: aMorph event: evt 
self addMorph: aMorph.
^true! !

!IAN_logMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/9/2014 12:48'!
wantsDroppedMorph: aMorph event: evt 
^true! !

Morph subclass: #IAN_clock
	instanceVariableNames: 'myTime myJobs textTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/21/2014 16:36'!
handlesMouseDown
^ false! !

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/9/2014 11:45'!
initialize 
| |
super initialize .
"appearence"
self color: Color lightBrown .
textTime := StringMorph new contents: ( myTime asString) .
textTime position: (self position + (12@5)).
self addMorph: textTime.
myJobs := OrderedCollection  new.
myTime := 0.
self stopStepping ! !

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:04'!
mouseDown: evt
evt shiftPressed ifTrue: [ (self isStepping) ifTrue: [ self stopStepping  ] ifFalse: [ self startStepping  ] ]! !

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/5/2014 21:25'!
myTime
^myTime ! !

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/6/2014 16:28'!
ownTime: aTime 
myTime := aTime! !

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/6/2014 14:34'!
setupJobat: aTime for: aReceiver selector: aSelectorString toGet: anArray 
myJobs addLast: ((IAN_job new) atTime: aTime give: aReceiver selector: aSelectorString message: anArray )! !

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/21/2014 15:15'!
step
| toDoes |
myTime := myTime + 1.
textTime contents: ( myTime asString) .
(myTime = 9999) ifTrue: [ myTime := 0 ].
" now see if there are call backs to do"
toDoes := myJobs select: [  : aJob | (aJob actionTime = myTime)  ]. " find the ones due now"

toDoes do: [ : thisToDo | "send the actiontoDoes "
	thisToDo actionReceiver perform: (thisToDo actionSelector) with: (thisToDo actionMessage )   . "perform: with:"
	myJobs remove: thisToDo . ]! !

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/5/2014 18:02'!
stepTime
 ^100 ! !

Morph subclass: #IAN_fieldMorph
	instanceVariableNames: 'numCCs numENs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_fieldMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/21/2014 11:15'!
acceptDroppingMorph: aMorph event: evt 
| num |

(aMorph class= IAN_barrier ) ifTrue: [  self addMorphBack:   aMorph ] ifFalse: [ self addMorph: aMorph ].
aMorph stopStepping .
"aMorph wiggle: 0 ."
(aMorph class = IAN_CC) ifTrue: [  num := (self numCCs: (self  numCCs + 1)). aMorph changeName: num] .
(aMorph class = IAN_EN)  ifTrue: [  num := (self numENs:  (self  numENs  + 1)). aMorph changeName: num] .

" give its clock a randome number"
aMorph hasClock ifTrue: [aMorph changeTime: 5000 atRandom].

aMorph inField: true .
^true! !

!IAN_fieldMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 20:14'!
hasNoPartsYet
numCCs := 0.
numENs  := 0
! !

!IAN_fieldMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 20:14'!
numCCs
^numCCs! !

!IAN_fieldMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 20:16'!
numCCs: aVal 
^numCCs := aVal! !

!IAN_fieldMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 20:15'!
numENs
^numENs! !

!IAN_fieldMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 20:16'!
numENs: aVal 
^numENs := aVal! !

!IAN_fieldMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 22:52'!
repelsMorph: aMorph event: evt 
^ (self wantsDroppedMorph: aMorph event: evt) not! !

!IAN_fieldMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 15:03'!
wantsDroppedMorph: aMorph event: evt 
"^((aMorph class = IAN_EN) or: [ (aMorph class = IAN_CC) or: [aMorph class = IAN_stateMachine] ])"
^true "for testing time"
! !

Morph subclass: #IAN_partsMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_partsMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/9/2014 12:22'!
acceptDroppingMorph: aMorph event: evt 
self addMorph:  aMorph .
aMorph inField: false .
aMorph stopStepping .
^true! !

!IAN_partsMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 13:33'!
wantsDroppedMorph: aMorph event: evt 
| aClass |
aClass := aMorph class.
^((aClass = IAN_Node) or: [ (aClass = IAN_barrier ) or: [aClass = IAN_stateMachine ] ]).! !

Object subclass: #IAN_Space
	instanceVariableNames: 'window fieldMorph partsMorph logMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_Space methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/5/2014 10:21'!
initialize 

super initialize.
window:=StandardWindow labelled: 'IAN_Space'.
fieldMorph := IAN_fieldMorph new.
window
      addMorph: fieldMorph
      fullFrame: (LayoutFrame
          fractions: (0@0 corner: 1@1)
          offsets: (100@0 corner: 0@125 negated)).
fieldMorph color: Color lightGray .
fieldMorph hasNoPartsYet.

partsMorph := IAN_partsMorph new.
window
      addMorph: partsMorph
      fullFrame: (LayoutFrame
          fractions: (0@0 corner: 0@1)
          offsets: (0@0 corner: 100@125 negated)).
partsMorph color: Color veryLightGray .

logMorph := IAN_logMorph new.
window
      addMorph: logMorph
      fullFrame: (LayoutFrame
          fractions: (0@1 corner: 1@1)
          offsets: (0@125 negated corner: 0@0)).
logMorph color: Color lightBlue .
  window openInWorld.
^self! !

!IAN_Space methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/9/2014 12:36'!
stage
| aCC anEN aStateMachine aBarrier|
" this method places element on to the IAN space"
aCC := (IAN_CC new) .
aCC myType: 'CC' .
aCC stopStepping .
aCC color: Color lightRed ; borderWidth: 2 ; useRoundedCorners .

anEN := (IAN_EN new).
anEN myType: 'EN' .
anEN color: Color lightGreen ; borderWidth: 2 ;useRoundedCorners .


aBarrier := IAN_barrier  new.
aBarrier verticesAt: 1 put: (0 @ 0).
aBarrier verticesAt: 2 put: (0 @25).
aBarrier verticesAt: 3 put: (25 @25).
aBarrier verticesAt: 4 put: (25 @0).
aBarrier beStraightSegments ; showOrHideHandles.
aBarrier dropRate:  0.5 .


partsMorph addMorphCentered: aBarrier.
partsMorph addMorphCentered: aCC . aCC stopStepping. 
partsMorph addMorphCentered: anEN . anEN stopStepping .
anEN      position: (anEN position + (0@85)).
aBarrier position: (aBarrier position +(0@150) negated).

"now add state machine holders"
aStateMachine := (IAN_stateMachine new).
aStateMachine color: Color transparent  ; borderWidth: 2 ; extent: (15@15). 
partsMorph addMorphCentered: aStateMachine.
aStateMachine position: (aStateMachine position - (10@80)).
" second one to hold other machine"
aStateMachine := (IAN_stateMachine new).
aStateMachine color: Color transparent  ; borderWidth: 2 ; extent: (15@15). 
partsMorph addMorphCentered: aStateMachine.
aStateMachine position: (aStateMachine position - (-10@80)).

logMorph addMorph: (DockingBarMorph new 
	addMorph: (SimpleButtonMorph new
                                           label: 'Turn On Logging';
                                           target: [UIManager inform: 'Hello'];
                                           actionSelector: #value);
	addMorph: (SimpleButtonMorph new
                                           label: 'Say bonjour';
                                           target: [UIManager inform: 'Bonjour'];
                                           actionSelector: #value);
	addMorph: (SimpleButtonMorph new
                                           label: 'Close';
                                           target: [DockingBarMorph allInstances last delete];
                                           actionSelector: #value);
	adhereToBottom)

! !

Object subclass: #IAN_job
	instanceVariableNames: 'actionTime actionReceiver actionSelector actionMessage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_job methodsFor: 'accessing' stamp: 'PhilipHunt 2/5/2014 18:32'!
actionMessage
^actionMessage! !

!IAN_job methodsFor: 'accessing' stamp: 'PhilipHunt 2/5/2014 18:31'!
actionReceiver
^actionReceiver! !

!IAN_job methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/6/2014 15:01'!
actionSelector
^actionSelector ! !

!IAN_job methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/6/2014 14:41'!
actionSelectorString: aStringToBeSymbol 
^aStringToBeSymbol  asSymbol! !

!IAN_job methodsFor: 'accessing' stamp: 'PhilipHunt 2/5/2014 18:29'!
actionTime
^actionTime ! !

!IAN_job methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/6/2014 14:43'!
atTime: aTime give: aReceiver selector: aSelectorString message: anArray
actionTime :=aTime.
actionReceiver := aReceiver.
actionSelector := self actionSelectorString: aSelectorString. "converts to symbol for us"
actionMessage := anArray! !

CircleMorph subclass: #IAN_message
	instanceVariableNames: 'startPosition targetPosition int barriersToPass message target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 19:52'!
barriersToPass
^barriersToPass ! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 19:53'!
barriersToPass: anArray 
barriersToPass := anArray
! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 20:06'!
barriersToPassRemove: aB 
| tempArray |
tempArray := self barriersToPass reject: [ :B | B = aB ].
self barriersToPass: tempArray
! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 20:09'!
initialize 
super initialize .
int:= 1.
self color: Color blue.
self extent: (8@8).
! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 22:24'!
int: aVal
int := aVal! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/21/2014 15:51'!
message
^message! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/21/2014 15:51'!
message: anArray 
" carries selector at 1 and with: at 2"
message := anArray! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/8/2014 20:15'!
setBarrierList
self barriersToPass:  (self owner submorphs select: [ :aM | aM class = IAN_barrier ] )
! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 16:48'!
startPosition
^startPosition! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 16:48'!
startPosition: aPos 
startPosition := aPos! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 22:21'!
startStepping
int := 1.
super startStepping ! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/23/2014 12:29'!
step
	" go from present position towards target position in about 30 steps"
	(self position dist: targetPosition) > 10
		ifTrue: [ 
			self position: startPosition + ((targetPosition - startPosition) * int // 30).
			int := int + 1.	" do we intersect with a barrier?"
			self barriersToPass
				do: [ :aB | 
					(aB containsPoint: self center)
						ifTrue: [ 
							aB statDel ifTrue: [ 	self delete.  Transcript show: 'statstical delete' ] ifFalse: [ self barriersToPassRemove: aB ]
								 ] ] ]
		ifFalse: [ 
			self stopStepping.
			message ifNotNil:  [(message size = 1) ifTrue: [target perform: (message at: 1) asSymbol ]
													ifFalse: [target perform: (message at: 1) asSymbol with:(message at:2) ]].
			self delete.
			Transcript show: 'Ive stopped' ]	" in a HIT we also kill the Morp if statstics say yes"! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 22:26'!
stepTime 
^30! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/21/2014 15:54'!
target: anotherNode 

target := anotherNode.! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 14:35'!
targetPosition
^targetPosition! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 14:34'!
targetPosition: aPosition 
targetPosition := aPosition ! !

CircleMorph subclass: #IAN_stateMachine
	instanceVariableNames: 'name stateChart inField inNode ballonText hasStates aWheel srcTokens'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 21:43'!
aWheel: aVal 
^aWheel at: aVal! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/26/2014 17:12'!
actOn: entryOrExit
| target |
" act the condition at the SM level not the state level"
target := self owner . " a node cc or en"

entryOrExit ifNotNil:  [(entryOrExit size = 1) ifTrue: [target perform: (entryOrExit at: 1) asSymbol ]
													ifFalse: [target perform: (entryOrExit at: 1) asSymbol with:(entryOrExit at:2) ]].


! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/26/2014 09:21'!
changeActiveStateTo: aNewOne
	stateChart activeState active: false.
	stateChart activeState: aNewOne.

	
! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/26/2014 11:28'!
checkmeAndAboveForTran: aState signal: aSignal targetSoFar: aTarget
"look at the active state first then all its parents for one active trans then report it"
| target next ans |

target := self test: aState forTranSignal: aSignal .
"WORKING HERE THE target GETS WRAPPED TOO DEEP WITH aTarget in the return"

target ifNil: [ 
	next := aState owner.
	(next class = IAN_state) ifFalse: [ ^aTarget] "effectively returns the same empty ordColl we entered with"
							 ifTrue:  [ 
									  ans := self checkmeAndAboveForTran:  next  signal: aSignal targetSoFar: aTarget.
									  (ans size ~= 0) ifTrue:  [  aTarget addFirst: '..' .
															   ^aTarget ] . " we found it and can end search"
									  "we never found it answer zero in size"
									 ^aTarget ].
	 ] ifNotNil: [ aTarget addAll: target. ^aTarget  ] .

! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 16:44'!
findNextInOc: anOC starting: position
	" returns new collection with contents up to next separator"

	| separators endPos |
	separators := #($> $<). 
	endPos := position.
	[ separators inject: false into: [ :sofar :delim | sofar or: [ delim = (anOC at: endPos) ] ] ]
		whileFalse: [ endPos := endPos + 1 ].
	^ endPos! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/26/2014 17:41'!
findTargetState: aTarget 
| dwnstates presentState val st |
aTarget removeFirst . "one too many double dots"

" follow this transition to a new state - return that state"
presentState := self stateChart activeState.
" first take off each double dot and move UP, execute EXIT along the way"
[aTarget first = '..'] whileTrue: [ "do the exit move up one, remove this double dot"
	(presentState exit) ifNotNil: [ self actOn: presentState doExit ].
	presentState := presentState owner.
	aTarget removeFirst .
	 ].

"then from first NUMbered element down execute ENTRY along the way"

[aTarget size ~= 0] whileTrue:  [
	val := (aTarget at: 1) asInteger .
	dwnstates := presentState submorphs select: [  :m | m class = IAN_state ].
	st:= dwnstates detect: [  :each | each num = val ].
	(st entry) ifNotNil: [self actOn: st doEntry].
	presentState := st .
	aTarget removeFirst.
	 ] .

^presentState.
! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/23/2014 12:17'!
handlesMouseDown: evt 
^ true! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 22:17'!
hasStates
^hasStates! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 20:49'!
hasStates: aBoolean 
hasStates := aBoolean ! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 22:01'!
inField
^inField! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 22:02'!
inField: aBol
inField:= aBol! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/23/2014 12:16'!
inNode
^inNode! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/23/2014 12:16'!
inNode: aval
inNode := aval.! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/20/2014 20:22'!
initialize
super initialize .
self inField: false.
self position: (0 @ 0).
self hasStates: false.
aWheel := Color lightCyan wheel: 8 .
! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/21/2014 14:59'!
makeStateFrom: aFile
	| aStream f endPos startPos outS outS2 lf cr |
	lf := Character lf.
	cr := Character cr.	" we read and parse the file into states"	
	f := StandardFileStream readOnlyFileNamed: aFile.
	f findString: '<statechart'.
	startPos := f position.
	endPos := f findStringFromEnd: '</statechart>'.
	endPos := endPos + '</statechart>' size.	" now put that in a String we can stream over"
		
	f position: startPos.
	aStream := OrderedCollection new.
	[ f atEnd or: [ f position = endPos ] ] whileFalse: [ aStream add: f next ].
	f close.	
		" remove cr/lf from it"
	outS := aStream reject: [ :c | c = lf or: [ c = cr ] ].	
		"place the relevent file contents in the token class variable for  the recursion"
	stateChart := IAN_stateChart new. 
	outS2 := self parseStates: outS. 
	"make it invisible"
	stateChart srcTokens: outS2. 
	stateChart srcFileName: aFile.
	stateChart name: aFile.	"red for better name"
	stateChart hide.
	
	stateChart makeStartingAtTop.

"	t := TransformationMorph  new asFlexOf: stateChart  .
	t scale: 1 ; position: (self position + (40@ (-80)) + stateChart extent ) ; smoothingOn  .
	stateChart hide.
	self addMorph: t. "

	stateChart position: (self position + (100@25)) .
	self addMorph: stateChart .
	self hasStates: true. 
! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/23/2014 12:20'!
mouseDown: evt 
| aFile |
evt controlKeyPressed ifTrue: [ World primaryHand attachMorph: self copy . ] .

evt shiftPressed ifTrue: [
						aFile := (UIManager default chooseFileMatching: {'*.qm'} ).
						aFile ifNotNil: [ self makeStateFrom: aFile.
										self color: (self aWheel: (aFile asString stringhash \\ 8) + 1)] ]
			ifFalse:  [ hasStates ifTrue: [stateChart visible: (stateChart  visible not) ]]


! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 1/28/2014 15:17'!
name
^name! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 1/28/2014 15:17'!
name: aString
name := aString.! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/12/2014 16:43'!
parseStates: anOC
	| pos atok allspaces result |
	
	result := OrderedCollection new.
	pos := 2. "first char is always $<"
	
	[ pos < anOC size ]
		whileTrue: [ 
			atok := anOC copyFrom: pos to: (self findNextInOc: anOC starting: pos) - 1.
			pos := pos + (atok size) +1. 
			allspaces := atok inject: true into: [ :sofar :ch | sofar and: [ ch = Character space ] ].
			allspaces
				ifFalse: [ result addLast: atok ] .				].
	^result 
! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/26/2014 09:23'!
signal: aSignal 
| possible newState |
" find out if this signal changes state"

possible := (OrderedCollection new) .
possible := self checkmeAndAboveForTran: (stateChart activeState) signal: aSignal  targetSoFar: possible .

(possible size ~= 0) ifTrue: [  "we found one to be done" 
	newState := self findTargetState: possible .
	self changeActiveStateTo: newState.
	]! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/25/2014 19:44'!
stateChart
^stateChart ! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/26/2014 11:26'!
test: aState forTranSignal: aSignal
" look into a state OR its super states and see if this signal activates a new state"
| trans activeTran |

trans :=aState submorphs select: [ :aM | aM class = IAN_tran ].
activeTran := trans detect: [ :each | (each trigger) = aSignal ] ifNone: [ ^nil].

^activeTran target
! !
